function formatFig(varargin)
% function formatFig(moveX,moveY,font)
%
% Ohne Vorgabe einer Verschiebung der axes verschwindet mitunter die
% Beschriftung einer Achse. In diesem Fall kann die axes mit moveX und
% moveY eingepasst werden. Weiterhin werden die Schrift - art und - gre
% eingestellt.
%
% moveX :   Verschiebung in x-Richtung
% moveY :   Verschiebung in y-richtung
% font  :   Benutzte Schriftart, default ist Palatino
%
% Autor: Wiebold Wurpts
% Datum: 15.07.2008
%        30.06.2010


% Auslesen vom Input
if nargin==0
    moveX = 0;
    moveY = 0;
else
    moveX = varargin{1};
    moveY = varargin{2};
end

if nargin>2
    font = varargin{3};
else
    font = 'Palatino';
end

% Sammeln aller Handles auf Text
h_leg    = legend;               
h_tit    = get(gca,'Title');    
h_all(1) = gca;
h_all(2) = get(gca,'XLabel');
h_all(3) = get(gca,'YLabel');
h_all(4) = get(gca,'ZLabel');
if ~isempty(h_tit) , h_all(end+1)=h_tit; end 
if ~isempty(h_leg) , h_all(end+1)=h_leg; end 

% Interpreter
set([h_leg h_tit],'Interpreter',get(gca,'DefaultTextInterpreter'));

%Formatierung der Schrift
set(h_all,   'FontSize',10);  % Schriftgre
set(gca,     'FontSize',10);  % Schriftgre der Ticks
set(h_leg,   'FontSize',6);   % nderung der Schriftgre der Legende (WvD)

% Schrift Palatino
set(h_all,'FontName',font);

% Einpassen der axes
a=get(gca,'Position');
set(gca,'Position',[a(1)+moveX a(2)+moveY a(3)-moveX a(4)-moveY]);






