function formatFig(varargin)
% function formatFig(moveX1,moveX2,moveY1,moveY2,font)
%
% Ohne Vorgabe einer Verschiebung der axes verschwindet mitunter die
% Beschriftung einer Achse. In diesem Fall kann die axes mit moveX und
% moveY eingepasst werden. Weiterhin werden die Schrift - art und - gre
% eingestellt.
%
% moveX :   Verschiebung in x-Richtung
% moveY :   Verschiebung in y-richtung
% font  :   Benutzte Schriftart, default ist Palatino
%
% Autor: Wiebold Wurpts
% Datum: 15.07.2008
%        30.06.2010


% Auslesen vom Input
if nargin==0
    moveX1 = 0;
    moveX2 = 0;
    moveY1 = 0;
    moveY2 = 0;
else
    moveX1 = varargin{1};
    moveX2 = varargin{2};
    moveY1 = varargin{3};
    moveY2 = varargin{4};
end

if nargin>4
    font = varargin{5};
else
    font = 'Palatino';
end

% Sammeln aller Handles auf Text
h_leg    = legend;               
h_tit    = get(gca,'Title');    
h_all(1) = gca;
h_all(2) = get(gca,'XLabel');
h_all(3) = get(gca,'YLabel');
h_all(4) = get(gca,'ZLabel');
if ~isempty(h_tit) , h_all(end+1)=h_tit; end 
if ~isempty(h_leg) , h_all(end+1)=h_leg; end 

% Interpreter
set([h_leg h_tit],'Interpreter',get(gca,'DefaultTextInterpreter'));

%Formatierung der Schrift
set(h_all,   'FontSize',12);  % Schriftgre
set(gca,     'FontSize',12);  % Schriftgre der Ticks
set(h_leg,   'FontSize',12);   % nderung der Schriftgre der Legende (WvD)
set(h_all(2),   'FontSize',16);  % X-Label
set(h_all(3),   'FontSize',16);  % Y-Label

% Schrift Palatino
set(h_all,'FontName',font);

% Einpassen der axes
a=get(gca,'Position');
set(gca,'Position',[a(1)+moveX1 a(2)+moveY1 a(3)-moveX1+moveX2 a(4)-moveY1+moveY2]);






