function h = openFig(varargin)
% function openFig(siz,interpreter)
%
% Die Funktion erstellt eine Figure der Gre siz und nimmt einige
% Einstellungen vor.
%
% siz           :  [width hight]  Vektor mit Weite und Hhe der figure in cm.
% (interpreter) :  optional , 'latex',('tex')
%
% Autor: Wiebold Wurpts
% Datum: 15.07.2008
%        30.06.2010


% Auslesen der Inputargumente
siz=varargin{1};
if nargin>1
    interpreter = varargin{2};
else
    interpreter = 'tex';
end

h = figure;

% Figure position
set(gcf,'Units','centimeters');
set(gcf,'Position',[5 5 siz]);

% Paper size
set(gcf,'PaperPositionMode','manual');  % ist auch default
set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperPosition',[0 0 siz]);
set(gcf,'PaperSize',siz);

% Default Einstellungen
set(gcf, 'DefaultAxesUnits'        , 'centimeters' );
set(gcf, 'DefaultLineLineWidth'    ,  1.5          );
set(gcf, 'DefaultTextInterpreter'  , interpreter   );


end

















