%% User input
clear,clc
close all
% Input filenames
inname = {'161101\400.unv', '161101\600.unv', '161101\800.unv', '161101\1000.unv', '161101\1200.unv', '161101\1500_Extrapunkt.unv', '161101\1700.unv', '161101\2000alt.unv', '161101\2500.unv', '161101\3000.unv'};
%'161101\200.unv', 
% Number of data sets
ndata = length(inname);

%% Load data

%
for ii = 1:ndata
    % Read data
    inname{ii}
    A = readuff(inname{ii});
    length(A{1,3}.nodeN)
end
%
% Load scan point location info
load scanloc_Charakterisierung_TestRig_FastScan_Envelopes_161101.mat %Variable: scanloc

% For each data set
for ii = 1:ndata
    % Read data
    inname{ii}
    A = readuff(inname{ii});
    scanpoints=A{1,3}.nodeN;
    %pups=length(scanloc)-length(scanpoints)
    length(scanpoints)
    iv = 0;
    for iii = 1:length(scanpoints) %first we check which measurementpoints are located on the membrane
        indscanloc=find(scanloc(:,1)==scanpoints(iii),1,'first');
        if scanloc(indscanloc,3)==0 %fr jeden Messpunkt bestimmen ob der auf dem Membran liegt und welche Position er hat.
        % fr jeden Messpunkt bestimmen ob der auf dem Membran liegt und welche Position er hat, 
        % des Weiteren die apicale Messpunkte (ab 118 mm, hier Messpunkte 20, 21, 22, 23, 52)
        % ausschlieen(!!!).
            iv=iv+1;
            scanlocBM(iv,1)=iii; %index in the data-file
            scanlocBM(iv,2)=scanloc(indscanloc,1); %node number
            scanlocBM(iv,3)=scanloc(indscanloc,2); %distance of the measurementpoint from the RW
        end
    end
    %ordArray = sortrows(scanlocBM,3);
    
    
    Vib = zeros(length(scanlocBM),8); %Initialize output
    Vib(:,1) = scanlocBM(:,2); %Node Number
    Vib(:,2) = scanlocBM(:,3); %Position
    for v = 1:length(scanlocBM)
        Vib(v,3) = abs(A{1,8}.r3(scanlocBM(v,1))); %Vib: LDV - Distance/Weg
        Vib(v,4) = angle(A{1,8}.r3(scanlocBM(v,1)))*360/(2*pi); %Vib: LDV - Distance/Weg
        Vib(v,5) = 0; %Reserved for the phase-dependent amplitude
        Vib(v,6) = abs(A{1,9}.r3(scanlocBM(v,1))); %Vib: LDV - Velocity/Geschwindigkeit
        Vib(v,7) = angle(A{1,9}.r3(scanlocBM(v,1)))*360/(2*pi); %Vib: LDV - Velocity/Geschwindigkeit
        Vib(v,8) = 0; %Reserved for the phase-dependent amplitude
    end
      
    freq(ii) = A{1,8}.modeFreq;
    k = strfind(A{1,8}.d1, ':');
    label_freq{ii} = A{1,8}.d1(k+2:end);
    
    [cd indexd] = max(Vib(:,3)) %maximale Amplitude gesucht
    theta0d = Vib(indexd,4)
    [cv indexv] = max(Vib(:,6))
    theta0v = Vib(indexv,7)
    
    for vi = 1:length(scanlocBM)
        Vib(vi,5)=Vib(vi,3)*cosd(Vib(vi,4)-theta0d);
        Vib(vi,8)=Vib(vi,6)*cosd(Vib(vi,7)-theta0v);
    end
    %Vib
    Vib = sortrows(Vib,2); %sorts the rows of Vib in ascending order of the second column (distance from the RW)
    
        %'Compensating' for the 'phasejump': 
    phasejump = 0;
    for vi = 1:length(scanlocBM)
        Vib(vi,4)=Vib(vi,4)+phasejump;
        if vi<length(scanlocBM)
            %if Vib(vi,4)<(-70+phasejump) && Vib(vi+1,4)>(70+phasejump)
            if Vib(vi+1,4)>(Vib(vi,4)-phasejump+100) %discriminator for the phasejump is set at 100 degrees.
                phasejump=phasejump-360;
            end
         end
    end
       

    %'Compensating' for the 'phasejump': 
    phasejump = 0;
    for vi = 1:length(scanlocBM)
        Vib(vi,8)=Vib(vi,8)+phasejump;
        if vi<length(scanlocBM)
            %if Vib(vi,4)<(-70+phasejump) && Vib(vi+1,4)>(70+phasejump)
            if Vib(vi+1,8)>(Vib(vi,8)-phasejump+100) %discriminator for the phasejump is set at 100 degrees.
                phasejump=phasejump-360;
            end
         end
    end

  iii=1;
  j=1
   while iii <= length(Vib)
       
         p = 1;
        
        if ((iii+1)<=length(Vib))
           if (abs(Vib(iii,2)-Vib(iii+1,2))<0.001)
           p=p+1;
           end 
        end
        if ((iii+2)<=length(Vib))
            if (abs(Vib(iii,2)-Vib(iii+1,2))<0.001)&&(abs(Vib(iii+1,2)-Vib(iii+2,2))<0.001)
           p=p+1; 
            end
        end
         medarray(j,1)=0;
         medarray(j,2)=median (Vib(iii:iii+p-1,2));
         medarray(j,3)=median (Vib(iii:iii+p-1,3));
         medarray(j,4)=median (Vib(iii:iii+p-1,4));
         medarray(j,5)=median (Vib(iii:iii+p-1,5));
         medarray(j,6)=median (Vib(iii:iii+p-1,6));
         medarray(j,7)=median (Vib(iii:iii+p-1,7));
         medarray(j,8)=median (Vib(iii:iii+p-1,8));
         
         j=j+1; 
        iii=iii+p;
          
   end
    
    k=(ii*4)+1;
   for w=1:length(medarray)
    allarray(w,k)=medarray(w,2);
    allarray(w,k+1)=medarray(w,3);
    allarray(w,k+2)=medarray(w,4);
    allarray(w,k+3)=medarray(w,5);
    w=w+1;
   end
   
%{
% Envelop map
OpenFig([8 6],'latex');
hold on
set(gcf,'DefaultLineLineWidth',1);
%plot(loc,R(ii,:))
plot(1e3*Vib(:,2),1e6*Vib(:,5),'-o',1e3*Vib(:,2),1e6*Vib(:,3),'r',1e3*Vib(:,2),-1e6*Vib(:,3),'r')
yl = ylim;
line([64.7 64.7], [yl(1) yl(2)], 'Color',[.8 .8 .8]);
legend(label_freq{ii},'Location','northeast')
xlim([0 140])
%ylim([-1 1])
NumTicksX = 8;
LX = get(gca,'XLim');
set(gca,'XTick',linspace(LX(1),LX(2),NumTicksX));
n=get(gca,'xtick');
set(gca,'xticklabel',sprintf('%0.0f|', n));
grid on
box on
xlabel('length $l~$[mm]')
%ylabel('amplitude A($\dot{q}_{\mathrm{res}})~[\frac{\mathrm{mm}}{\mathrm{s}}]$')
ylabel('amplitude A($q_{\mathrm{res}})~[\mu \mathrm{m}]$')
%legend('$F_{\mathrm{a,10mm}}$','$F_{\mathrm{a,20mm}}$','$F_{\mathrm{a,30mm}}$','Location','NorthEast')
FormatFig(-0.7,0.2);
PlotFig(['Envelope at ' label_freq{ii} ' (' inname{ii}(1:5) ')']);
%}

% Envelop map with phase
OpenFig([8 6],'latex');
%hold on
hold all
set(gcf,'DefaultLineLineWidth',0.5); %linienstrke
%ii=3;
[ax,hLine1,hLine2] = plotyy([1e3*medarray(:,2),1e3*medarray(:,2),1e3*medarray(:,2)],[1e6*medarray(:,5),1e6*medarray(:,3),-1e6*medarray(:,3)],1e3*medarray(:,2),medarray(:,4)/180);
yl = ylim;
grey=[0.6,0.6,0.6];
%line([44.7 44.7], [yl(1) yl(2)], 'Color',grey);
%%{
%xrange=[69 120];
%{
if ii==3 %100Hz
    xrange=[69 120]
    y0=0
    A=0.62328
    xc=92.40114
    s=18.06938
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[58 70]
    y0=0
    A=0.21756
    xc=64.6065
    s=1.88984
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
end
if ii==4 %200Hz
    xrange=[69 120]
    y0=0
    A=1.09025
    xc=82.87517
    s=8.22034
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[49 120]
    y0=0
    A=1.04547
    xc=83.152
    s=7.7282
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[58 70]
    y0=0
    A=1.30386
    xc=64.43343
    s=2.14213
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
end
if ii==5 %250Hz
    xrange=[69 120]
    y0=0
    A=1.95482
    xc=79.43673
    s=4.77903
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[49 120]
    y0=0
    A=1.96925
    xc=79.41553
    s=4.83094
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[58 70]
    y0=0
    A=2.12186
    xc=64.37377
    s=2.14934
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
end
if ii==6 %300Hz    
    xrange=[69 120]
    y0=0
    A=2.4195
    xc=75.54372
    s=4.97919
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[49 120]
    y0=0
    A=5.23506
    xc=69.07922
    s=9.06124
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[58 70]
    y0=0
    A=2.53702
    xc=65.12345
    s=2.45872
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
end
if ii==7 %400Hz
    xrange=[69 120]
    y0=0
    A=2.34416
    xc=73.09763
    s=3.24475
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[49 120]
    y0=0
    A=11.43166
    xc=65.60103
    s=5.96223
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[58 70]
    y0=0
    A=4.12301
    xc=64.9861
    s=2.52917
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
end
if ii==8 %500Hz
    xrange=[69 120]
    y0=0
    A=2.33505
    xc=72.61351
    s=3.41581
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[49 120]
    y0=0
    A=10.26942
    xc=65.75939
    s=5.77954
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[58 70]
    y0=0
    A=4.21365
    xc=65.17021
    s=2.47294
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
end
if ii==13 %900Hz
    xrange=[69 120]
    y0=0
    A=1.16726
    xc=75.40958
    s=2.41144
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[49 120]
    y0=0
    A=4.20632
    xc=67.3651
    s=9.52528
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[58 70]
    y0=0
    A=3.40591
    xc=65.12797
    s=1.13571
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
end
if ii==14 %1000Hz
    xrange=[69 120]
    y0=0
    A=0.90538
    xc=75.24096
    s=3.02877
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[49 120]
    y0=0
    A=2.45764
    xc=69.59695
    s=7.80508
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[58 70]
    y0=0
    A=2.06805
    xc=65.24844
    s=1.40875
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
end
%}
%{
if ii==16 %1500Hz
    xrange=[69 120]
    y0=0
    A=0.39913
    xc=33
    s=1.93394
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
    xrange=[69 120]
    y0=2.6602E-6
    A=0.72318
    xc=33.49215
    s=5.99899
    f = @(x) y0+A.*exp(-(x-xc).^2/(2*s.^2))/sqrt(2*pi*s.^2); %Gaussian-Function
    fplot(f,[xrange],'-k')
end
%}
xlim(ax(1),[0 140])
xlim(ax(2),[0 140])
%ylim(ax(1),[0 400])
%ylim(ax(2),[-6 6])
set(ax(2),'xticklab',[],'xtick',[])
set(hLine1(1),'color','b')
set(hLine1(2),'color','g')
set(hLine1(3),'color','g')
set(hLine1(1),'Marker','.')
set(hLine2,'color','r') 
set(ax(1),'YColor','b');
set(ax(2),'YColor','r'); 
NumTicksX = 8;
LX1 = get(ax(1),'XLim');
LX2 = get(ax(2),'XLim');
set(ax(1),'XTick',linspace(LX1(1),LX1(2),NumTicksX));
set(ax(2),'XTick',linspace(LX2(1),LX2(2),NumTicksX));
%NumTicksY = 7;
%LY1 = get(ax(1),'YLim');
%LY2 = get(ax(2),'YLim');
%set(ax(1),'YTick',linspace(LY1(1),LY1(2),NumTicksY));
%set(ax(2),'YTick',linspace(LY2(1),LY2(2),NumTicksY));
n=get(gca,'xtick');
set(gca,'xticklabel',sprintf('%0.0f|', n));
%grid(ax(1),'on');
grid on
box on
xlabel(ax(1),'length $l_{\mathrm{BM}}~[\mathrm{mm}]$')
ylabel(ax(1),'amplitude A($q_{\mathrm{res}})~[\mu \mathrm{m}]$')
%ylabel(ax(2),'phase $\varphi~[\mathrm{^{\circ}}]$')
ylabel(ax(2),'phase $[\mathrm{\Pi}]$')
legend(label_freq{ii},'Location','northeast')
FormatFigYY(0.5,-1.2,0.4);
set(legend,'FontSize',6);
PlotFig(['BM envelope and phase at ' label_freq{ii} ' (' inname{ii}(1:5) ') Median']);
%%}

%{
B = [1e3*Vib(:,2), 1e6*Vib(:,3)];
filename = ['LDVdata3_', label_freq{ii}, '.txt'];
save(filename, 'B', '-ascii');
%}

clearvars scanlocBM %Since this variable is not initialized / cleared after each sequence
end

%aktor_data3=Vib;
%save aktor_data3_100Hz.mat aktor_data3 -mat;
